﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Xml.Linq;

namespace WebUnhandledException
{
    public class Global : System.Web.HttpApplication
    {
        static string _sourceName = null;

        static Global()
        {
            string webenginePath = Path.Combine(RuntimeEnvironment.GetRuntimeDirectory(), "webengine.dll");
            FileVersionInfo ver = FileVersionInfo.GetVersionInfo(webenginePath);
            _sourceName = string.Format(CultureInfo.InvariantCulture, "ASP.NET {0}.{1}.{2}.0",
                                                    ver.FileMajorPart, ver.FileMinorPart, ver.FileBuildPart);
        }

        protected void Application_Start(object sender, EventArgs e)
        {
            
        }

        protected void Session_Start(object sender, EventArgs e)
        {

        }

        protected void Application_BeginRequest(object sender, EventArgs e)
        {

        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {
            //ExceptionHandler.LogException exc = new ExceptionHandler.LogException();
            Exception ex = Server.GetLastError().GetBaseException();
            this.Response.Write(ex.Message + ex.StackTrace);

            // pass ex to your logging or notification utility
            StringBuilder message = new StringBuilder("\r\n\r\nUnhandledException logged by Application_Error og Global.asax:\r\n\r\nappId=");
            string appId = (string)AppDomain.CurrentDomain.GetData(".appId");
            if (appId != null)
            {
                message.Append(appId);
            }

            message.Append(ex.Message + ex.StackTrace);

            EventLog Log = new EventLog();
            Log.Source = _sourceName;
            Log.WriteEntry(message.ToString(), EventLogEntryType.Error);
        }

        protected void Session_End(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {

        }
    }
}